# require_relative 'methods/web_methods'
require_relative 'methods/required_files'
# page title checking
Then(/^I should\s*((?:not)?)\s+see page title as "(.*?)"$/) do |present, title|
  check_title(title, present.empty?)
end

Then(/^I should\s*((?:not)?)\s+see page title having partial text as "(.*?)"$/) do |present, partial_text_title|
  check_partial_title(partial_text_title, present.empty?)
end

# check property for object
Then /^I check property "(.*?)" with "(.*?)" has( | not)? value "(.*?)"$/ do |object, property, negate, value|
  value = var_collect(value)
  execute_checkproperty(object, property, negate, value)
end

Then /^the following multiline step should (fail|succeed):$/ do |expectation, multiline_step|
  multiline_step = multiline_step.gsub(%{'''}, %{"""})
  if expectation == 'fail'
    expect { steps(multiline_step) }.to raise_error(RSPEC_EXPECTATION_NOT_MET_ERROR)
  else # succeed
    steps(multiline_step)
  end
end

Then /^the following steps? should (fail|succeed):$/ do |expectation, steps_table|
  steps = steps_table.raw.flatten

  steps.each do |step|
    if expectation == 'fail'
      expect { step(step) }.to raise_error(RSPEC_EXPECTATION_NOT_MET_ERROR)
    else # succeed
      step(step)
    end
  end
end

Then /^I should see a form with the following values:$/ do |table|
  expectations = table.raw
  expectations.each do |label, expected_value|
    step %(I check property "#{label}" with "text" has value "#{expected_value}")
  end
end

Then /^Status of "([^\"]*)" should be "(disabled|enabled)"$/ do |element, status|
  puts "status: #{status} => status =='disabled': #{status =='disabled'}"
  foundElement = if(status =='disabled')
                   find_object(element + "{'disabled':'true'}")
                 elsif (status =='enabled')
                   find_object(element + "{'disabled':''}")
                 else
                   puts "Error >> '#{status }' status is not support."
                   exit
                 end

  if foundElement == nil
    puts "Error >> Not found object..."
    exit
  end
end

And /^I check( not)? exists element is "(.*?)"$/ do |negate, object|
  #negate = negate.strip if negate != nil
  execute_checkexists(negate, object,2)
end

# step to assert checkbox is checked or unchecked
Then(/^checkbox "(.*?)" should be (checked|unchecked)$/) do |element, state|
  flag = state == 'checked'
  is_checkbox_checked(element, flag)
end

# steps to assert radio button checked or unchecked
Then(/^radio button "(.*?)" should be (selected|unselected)$/) do |element, state|
  flag = state == 'selected'
  is_radio_button_selected(element, flag)
end

# step to assert javascript pop-up alert text
Then(/^I should see alert text as "(.*?)"$/) do |actual_value|
  check_alert_text(actual_value)
end

# step to assert difference in images
Then(/^actual image having (.+) "(.*?)" and expected image having (.+) "(.*?)" should be similar$/) do |actual_img_access_type, actual_img_access_name, excp_img_access_type, excp_img_access_name|
  IFD_Assertion.does_images_similar?(actual_img_access_type, actual_img_access_name, excp_img_access_type, excp_img_access_name)
end

# step to check element enabled or not
Then(/^element "([^\"]*)" should\s*((?:not)?)\s+be (enabled|disabled)$/) do |element, present, state|
  flag = state == 'enabled'
  flag = !flag unless present.empty?
  check_element_enable(element, flag)
end

