require 'mail'
require_relative 'methods/required_files'
# Before do
#   ActionMailer::Base.deliveries.clear
# end

Then /^I send the email to "(.*)" with subject is "(.*)" and email body in "(.*)" file$/ do |to_address, subject, file|
  data_file = File.read($test_data_dir + file)
  filepath = ($test_data_dir + file)
  body_email = data_file.force_encoding('UTF-8').encode('UTF-16', :invalid => :replace, :replace => "'").encode('UTF-8')
  if File.exist?(filepath)
    IFD_Email.send_email(to_address, subject, body_email)
  end
end
Then /^I send the email to "(.*)" with subject is "(.*)" and email body "(.*)"$/ do |to_address, subject, email_body|
  email_body = email_body.force_encoding('UTF-8').encode('UTF-16', :invalid => :replace, :replace => "'").encode('UTF-8')
  IFD_Email.send_email(to_address, subject, email_body)
end

Then /^I should receive the email from "(.*)" with subject "(.*)"$/ do |email_from, email_subject|
  sleep 5
  emails = Mail.find(:what => :last, :count => 1)
  if emails.instance_of? Mail::Message
    # puts emails.from[0].to_s
    IFD_Assertion.assert_string_equal(email_from, emails.from[0].to_s)
    IFD_Assertion.assert_string_equal(email_subject, emails.subject)
  else
    raise "WARNING: *** No new Email is found"
  end
end

Then /^I should receive the mail from "(.*)" with Email content has following value:$/ do |email_from, email_content|
  sleep 5
  emails = Mail.find(:what => :last, :count => 1)
  if emails.instance_of? Mail::Message
    IFD_Assertion.assert_string_equal(email_from, emails.from[0].to_s)
    email_content.raw[0].each do |line|
      assert(true) if emails.body.should include(line.strip)
    end
  else
    raise "WARNING: *** No new Email is found"
  end
end

Then /^I should receive the mail from "(.*)" with subject "(.*)" amd Email content has following value:$/ do |email_from,email_subject, email_content|
  sleep 5
  emails = Mail.find(:what => :last, :count => 1)
  if emails.instance_of? Mail::Message
    IFD_Assertion.assert_string_equal(email_from, emails.from[0].to_s)
    IFD_Assertion.assert_string_equal(email_subject, emails.subject)
    email_content.raw[0].each do |line|
      assert(true) if emails.body.should include(line.strip)
    end
  else
    raise "WARNING: *** No new Email is found"
  end
end

Then /^I send the email to "(.*)" with subject is "(.*)" and email body template in "(.*)" file and following conditions:$/ do |to_address, subject, file, data_table|
  data_file = File.read($test_data_dir + file)
  filepath = ($test_data_dir + file)
  body_email = data_file.force_encoding('UTF-8').encode('UTF-16', :invalid => :replace, :replace => "'").encode('UTF-8')
  if File.exist?(filepath)
    raw_data = JSON.parse(JSON.generate(data_table))
    header = raw_data[0]
    value = raw_data[1]
    $test = String.new
    $i = 0
    body_email.each_line do |lines|
      header.zip(value).each do |headers, values|
        group1, group2, group3= lines.match(/(^.*)(:)(.*)/i).try(:captures)
        if headers == group1 && group1.size > 0
          $new_value = lines.gsub(group3, " #{values}")
          $test += "#{$new_value}"
          $i = 1
          break
        elsif headers == "taaknummer"
          $new_value = lines.gsub("[TASKID]", " #{values}")
          $test += "#{$new_value}"
          $i = 1
        else
          $i = 0
        end
      end
      if $i == 0
        $test += "#{lines}"
      end
    end
    IFD_Email.send_email(to_address, subject, $test)
  end
end
