require 'nokogiri'
require_relative 'methods/required_files'
# Send POST XML request with data in $test_data_dir
When /^I send a POST XML request to "(.*?)" with the following file "(.*?)"$/ do |type, file|
  file = Util.bind_with_dyn_vars(file)
  url = Util.bind_with_dyn_vars($WS_URL)
  # url=$WS_URL
  data = File.read($test_data_dir + file)
  $result=IFD_WS.send_XML_post_webservice(url,type,data)
end
# Verify XML response with data is table format
Then /^The XML response of "(.*)" should be the following:$/ do |xpath,table|
  data = table.raw
  expected_result=data[0][0]
  data = Nokogiri::XML.parse($result).remove_namespaces!
  actual_result= data.xpath(xpath).to_s
  # puts expected_result.to_s
  puts actual_result.to_s
  # Do assert with the different size of xml
  IFD_Assertion.assert_string_equal(expected_result,actual_result)
end
# Send POST XML request with template in $test_data_dir and condition is table format
When /^I send a POST XML request to "(.*?)" with file template "(.*?)" and following conditions:$/ do |type, file, data_table|
  file = Util.bind_with_dyn_vars(file)
  url = Util.bind_with_dyn_vars($WS_URL)
  data = File.read($test_data_dir + file)
  raw_data = JSON.parse(JSON.generate(data_table))
  header = raw_data[0]
  value = raw_data[1]
  i = 0
  header.zip(value).each do |headers, values|
    value_condition = Nokogiri::XML.parse(data).xpath("//"+headers).to_s
    tag_value= value_condition[/.*\>(.*?)</, 1]
    $new_value = value_condition.gsub(tag_value, values)
    if i>0 then
      $data_new= $data_new.gsub(value_condition, $new_value)
    else
      $data_new=data.gsub(value_condition, $new_value)
    end
    i = i+1
  end
  $result=IFD_WS.send_XML_post_webservice(url, type, $data_new)
end

